#include <stdafx.h>
#include "CommonDef.h"

map<int, CString>    g_mapProductModelName;

void InitializeProductModelName()
{
#define INSERT_PRODUCTMODEL(_ID)      g_mapProductModelName.insert(std::pair<int, CString>(_ID, #_ID));

	INSERT_PRODUCTMODEL(TC_NVSS);
	INSERT_PRODUCTMODEL(TC_NS621S);
	INSERT_PRODUCTMODEL(TC_NS621S_USB);
	INSERT_PRODUCTMODEL(TC_NS224S);
	INSERT_PRODUCTMODEL(TC_NC621S);
	INSERT_PRODUCTMODEL(TC_NC8000S);
	INSERT_PRODUCTMODEL(TC_NC8001S);
	INSERT_PRODUCTMODEL(TC_NC8100S);
	INSERT_PRODUCTMODEL(TC_NC8101S);
	INSERT_PRODUCTMODEL(TC_NC8200S);
	INSERT_PRODUCTMODEL(TC_NC8250);
	INSERT_PRODUCTMODEL(TC_NC9010S2_MP);
	INSERT_PRODUCTMODEL(TC_NC9000S2_2MP);
	INSERT_PRODUCTMODEL(TC_NS621S2);
	INSERT_PRODUCTMODEL(TC_NS324S2);
	INSERT_PRODUCTMODEL(TC_NS628S2);
	INSERT_PRODUCTMODEL(TC_NC9010I_2MP);
	INSERT_PRODUCTMODEL(TC_NC9000I_5MP);
	INSERT_PRODUCTMODEL(TC_2816AN_SH);
	INSERT_PRODUCTMODEL(TC_2808AN_S_3511);
	INSERT_PRODUCTMODEL(TC_2816AN_SD);
	INSERT_PRODUCTMODEL(TC_2808AN_S_3515);
	INSERT_PRODUCTMODEL(TC_2816AN_S);
	INSERT_PRODUCTMODEL(TC_1002S2_3C);
	INSERT_PRODUCTMODEL(TC_ND921S2_MP);
	INSERT_PRODUCTMODEL(TC_2804AN_MX);
	INSERT_PRODUCTMODEL(TC_H908NC_H_V50);

	INSERT_PRODUCTMODEL(TC_H802BHX_T);
}

CString GetProductModelName(int _iModel)
{
	CString strTmp;
	strTmp.Format("0x%x", _iModel);
	CString strDevType = "undefined-" + strTmp + "";

	map<int, CString>::iterator it = g_mapProductModelName.find(_iModel);
	if (it != g_mapProductModelName.end())
		strDevType = it->second;

	return strDevType;
}

VARIANT getstovar(CString _szSrc)
{
	VARIANT var;
	VariantInit(&var);
	V_BSTR(&var) = _szSrc.AllocSysString();
	V_VT(&var) = VT_BSTR;
	return var;
}

VARIANT getitovar(int _iSrc)
{
	VARIANT var;
	VariantInit(&var);
	var.vt = VT_UINT;
	var.intVal = _iSrc;
	return var;
}

int SplitStringToArray( const char* _pstrStingSource,const char* _pstrSplitChar,CStringArray& _strArray )
{
	int iArrayCount = 0;

	CString strTem;
	while(AfxExtractSubString(strTem,_pstrStingSource,iArrayCount,_pstrSplitChar[0]))
	{
		_strArray[iArrayCount++] = strTem;
	}
	return iArrayCount;
}

int CheckRetValue(CString szReturn, CStringArray& _strArray)
{
	SplitStringToArray(szReturn, _T("\n"), _strArray);
	if (_strArray[0] != "0")
	{
		return _ttoi(_strArray[0]);
	}
	return 0;
}

int GetRetValue(CString szReturn, CStringArray& _strArray)
{
	SplitStringToArray(szReturn, _T("\n"), _strArray);
	if (_strArray[0] != "0")
	{
		return _ttoi(_strArray[0]);
	}
	return 0;
}

bool IsDirectory(const char* strFileOrDirectoryFullPath)
{
	DWORD theFileAttribute = GetFileAttributes(strFileOrDirectoryFullPath);
	if(( theFileAttribute != -1 ) && (theFileAttribute & FILE_ATTRIBUTE_DIRECTORY) != 0)
		return TRUE;
	else return FALSE;
}

bool CreateDirectoryByPath(CString strFullPath)
{
	if (strFullPath.GetLength()<2
		||	strFullPath[1]	!=	':')
		return	false;

	CString	strTmp;
	int		iPos	=	0;
	bool	blRet	=	true;
	do 
	{
		iPos	=	strFullPath.Find('\\',	iPos);
		if (-1	==	iPos)
			strTmp	=	strFullPath;
		else
			strTmp	=	strFullPath.Left(++iPos);

		if(IsDirectory(strTmp) == false)
		{
			if(CreateDirectory(strTmp,NULL) == 0)
			{
				blRet	=	false;
				break;
			}
		}
	} while (-1	!=	iPos);
	return	blRet;
}


//תΪʱ
void AbsSecondsToNvsFileTime( NVS_FILE_TIME* _fileTime,long _tTime )
{
	time_t ltime = (time_t)_tTime;
	struct tm pTime = {0};
	gmtime_s(&pTime, &ltime);
	_fileTime->iYear = pTime.tm_year + 1900;
	_fileTime->iMonth = pTime.tm_mon + 1;
	_fileTime->iDay = pTime.tm_mday;
	_fileTime->iHour = pTime.tm_hour;
	_fileTime->iMinute = pTime.tm_min;
	_fileTime->iSecond = pTime.tm_sec;
}

//ʱתΪ
unsigned int NvsFileTimeToAbsSeconds( NVS_FILE_TIME * _pFileTime )
{
	tm tm_Begin = {0};
	tm_Begin.tm_year = _pFileTime->iYear - 1900;
	tm_Begin.tm_mon  = _pFileTime->iMonth - 1;
	tm_Begin.tm_mday = _pFileTime->iDay;
	tm_Begin.tm_hour = _pFileTime->iHour;
	tm_Begin.tm_min  = _pFileTime->iMinute;
	tm_Begin.tm_sec  = _pFileTime->iSecond;

	time_t timenow, timeSpace;
	tm  pTimeg= {0} ;
	time(&timenow);
	gmtime_s(&pTimeg, &timenow);
	timeSpace = timenow - mktime(&pTimeg);
	time_t begin = mktime(&tm_Begin) + timeSpace;
	unsigned int uiSeconds = (unsigned int)begin;
	return uiSeconds;
}

