﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace SwallowDemo
{
    public partial class PlayBack : Form
    {
        private const int Query_Query_Cmd = 0x00090000;

        private const int Store_DLStart_Cmd = 0x000a0011;
        private const int Store_DLStop_Cmd = 0x000a0012;
        private const int Store_DLProgress_Get = 0x000a0013;
        private const int Store_LocalPath_Get = 0x000a0002;

        private const int Obs_StartPlayBack_Cmd = 0x00020005;
        private const int Obs_Add_Cmd = 0x00020002;
        private const int Obs_Progress_Get = 0x00020010;
        private const int Obs_Stop_Cmd = 0x00020009;
        private const int Obs_StartPlayBackOffLine_Cmd = 0x00020015;

        private const int DEVICE_DECRYPTREC_SET = 0x00140002;
        private const int DEVICE_DECRYPTREC_GET = 0x00140003;

        private const int LMSG_PLAYBACK_NEED_DECRYPT_KEY = 0x00000015;
        private const int LMSG_PLAYBACK_DECRYPT_KEY_FAILED = 0x00000016;
        private const int LMSG_PLAYBACK_DECRYPT_SUCCESS = 0x00000017;

        private const int PAGE_NUM = 10;
        private int m_iLogonID = -1;
        private int m_iChannelNum = 0;
        Dictionary<UInt32, int> m_mapDownloadID;
        int m_iObsID = -1;
        private string m_strLocalPath = "C:\\NetVideoBrowser\\";
        private string m_strIPAddress = "";

        public int LogonID
        {
            get { return m_iLogonID; }
            set { m_iLogonID = value; }
        }

        public int ChannelNum
        {
            get { return m_iChannelNum; }
            set { m_iChannelNum = value; }
        }

        public string IPAddress
        {
            get { return m_strIPAddress; }
            set { m_strIPAddress = value; }
        }

        public PlayBack()
        {
            InitializeComponent();
        }

        private void PlayBack_Load(object sender, EventArgs e)
        {
            string[] strRet = ocxPlayBack.Commander(Obs_Add_Cmd, 0, 0, 0, 0, 0, 0, 0, 0, 0).Split('\n');
            int iRet = Int32.Parse(strRet[0]);
            if (iRet == 0)
            {
                m_iObsID = Int32.Parse(strRet[1]);
            }

            for (int i = 0; i < ChannelNum; ++i)
            {
                cboChannel.Items.Add("CH" + (i + 1));
            }
            cboChannel.SelectedIndex = 0;

            cboFileType.SelectedIndex = 0;
            cboRecType.SelectedIndex = 0;

            m_mapDownloadID = new Dictionary<UInt32, int>();

            string[] strPath = ocxPlayBack.Commander(Store_LocalPath_Get,
                0, 0, 0, 0, 0, 0, 0, 0, 0).Split('\n');
            iRet = Int32.Parse(strPath[0]);
            if (iRet == 0)
            {
                m_strLocalPath = strPath[1];
            }

            edtIP.Text = m_strIPAddress;

            dateBegin.Value = DateTime.Now.AddDays(-6);
        }

        private int QueryFile(int iPage)
        {
            int iChannel = cboChannel.SelectedIndex;
            int iFileType = cboFileType.SelectedIndex + 1;
            int iRecordType = cboRecType.SelectedIndex;
            if (iRecordType == 0)
            {
                iRecordType = 0xFF;
            }
            string strBeginTime = dateBegin.Value.ToString("yyyyMMdd") +
                timeBegin.Value.ToString("HHmmss");
            string strEndTime = dateEnd.Value.ToString("yyyyMMdd") +
                timeEnd.Value.ToString("HHmmss");
            int iRet = StrToInt(ocxPlayBack.Commander(Query_Query_Cmd,
                LogonID, iChannel, 1, iFileType, iRecordType, strBeginTime,
                strEndTime, PAGE_NUM, iPage));
            if (iRet < 0)
            {
                AppendMsg("Query File Failed! LogonID(" + LogonID +
                    ") Channel(" + iChannel + ") FileType(" + iFileType +
                    ") RecType(" + iRecordType + ") Begin(" +
                    strBeginTime + ") End(" + strEndTime +
                    ") Page(" + iPage + ") Ret(" + iRet + ")\r\n\r\n");
            }
            return iRet;
        }

        private void btnQuery_Click(object sender, EventArgs e)
        {
            QueryFile(0);
        }

        int StrToInt(string strData)
        {
            int iData = 0;
            try
            {
                iData = Convert.ToInt32(strData);
            }
            catch (System.Exception /*ex*/)
            {
                iData = 0;
            }
            return iData;
        }

        private void ocxPlayBack_QueryResult(object sender, AxSwallowLib._DSwallowEvents_QueryResultEvent e)
        {
            if (e._lLogonID == LogonID)
            {
                string[] strRet = e._bstrResult.Split('\n');
                int iRet = StrToInt(strRet[0]);
                if (iRet == 0)
                {
                    string[] strFileInfo = strRet[1].Split('\b');
                    int iCount = StrToInt(strFileInfo[0]);
                    int iTotal = StrToInt(strFileInfo[1]);
                    int iTotalPage = iTotalPage = (iTotal + PAGE_NUM - 1) / PAGE_NUM;
                    edtTotalPage.Maximum = iTotalPage;
                    edtTotalPage.Minimum = iTotalPage;
                    edtTotalPage.Value = iTotalPage;
                    edtCurrentPage.Maximum = iTotalPage;
                    edtCurrentPage.Minimum = iTotalPage > 0 ? 1 : 0;
                    gridFiles.Rows.Clear();
                    for (int i = 2; i < iCount + 2; ++i)
                    {
                        gridFiles.Rows.Add
                        (
                            new object[]
                            { 
                                i-1,
                                strRet[i]
                            }
                        );
                    }
                    gridFiles.Invalidate();
                }
                else
                {
                    AppendMsg("Query Failed! Ret(" + iRet + ")\r\n\r\n");
                }
            }
        }

        private void btnGotoPage_Click(object sender, EventArgs e)
        {
            int iCurrentPage = Convert.ToInt32(edtCurrentPage.Value) - 1;
            if (iCurrentPage < 0)
            {
                iCurrentPage = 0;
            }
            QueryFile(iCurrentPage);
        }

        private void btnDownload_Click(object sender, EventArgs e)
        {
            if (btnDownload.Text == "Download")
            {
                m_mapDownloadID.Clear();
                foreach (DataGridViewRow row in gridFiles.SelectedRows)
                {
                    string strFileName = row.Cells["FileName"].Value.ToString();
                    string[] strRet = ocxPlayBack.Commander(Store_DLStart_Cmd,
                        LogonID, strFileName, m_strLocalPath + strFileName, 0, 0,
                        0, 0, 0, 0).Split('\n');
                    int iRet = StrToInt(strRet[0]);
                    if (iRet == 0)
                    {
                        UInt32 uiDownloadID = Convert.ToUInt32(strRet[1]);
                        m_mapDownloadID.Add(uiDownloadID, row.Index);
                    }
                    else
                    {
                        AppendMsg("Start Download Failed! LogonID(" +
                            LogonID + ") FileName(" + strFileName +
                            ") Ret(" + iRet + ")\r\n\r\n");
                    }
                }
                if (m_mapDownloadID.Count > 0)
                {
                    btnDownload.Text = "Stop";
                    btnGotoPage.Enabled = false;
                    btnQuery.Enabled = false;
                    timerDownload.Enabled = true;
                }
            }
            else
            {
                foreach (UInt32 uiID in m_mapDownloadID.Keys)
                {
                    string strRet = ocxPlayBack.Commander(Store_DLStop_Cmd,
                        uiID, 0, 0, 0, 0, 0, 0, 0, 0);
                    int iRet = StrToInt(strRet);
                    if (iRet != 0)
                    {
                        AppendMsg("Stop Download Failed! DownloadID(" +
                            uiID + ") Ret(" + iRet + ")\r\n\r\n");
                    }
                }
                m_mapDownloadID.Clear();
                btnDownload.Text = "Download";
                timerDownload.Enabled = false;
                btnGotoPage.Enabled = true;
                btnQuery.Enabled = true;
            }
        }

        private void ocxPlayBack_OnDownLoad(object sender, AxSwallowLib._DSwallowEvents_OnDownLoadEvent e)
        {
            ocxPlayBack.Commander(Store_DLStop_Cmd, e._ulMsg, 0, 0, 0, 0, 0, 0, 0, 0);

            if (m_mapDownloadID.ContainsKey(e._ulDLID))
            {
                DataGridViewRow row = gridFiles.Rows[m_mapDownloadID[e._ulDLID]];
                if (e._ulMsg == 0)
                {
                    row.Cells["Download"].Value = "Finished";
                    AppendMsg("Download Finished! DownloadID(" +
                            e._ulMsg + ")\r\n\r\n");
                }
                else
                {
                    row.Cells["Download"].Value = "Failed";
                    AppendMsg("Download Failed! DownloadID(" +
                            e._ulMsg + ")\r\n\r\n");
                }
                m_mapDownloadID.Remove(e._ulDLID);
            }
            if (m_mapDownloadID.Count <= 0)
            {
                btnDownload.Text = "Download";
                timerDownload.Enabled = false;
                btnGotoPage.Enabled = true;
                btnQuery.Enabled = true;
            }
        }

        private void btnPlay_Click(object sender, EventArgs e)
        {
            if (btnPlay.Text == "Play")
            {
                if (gridFiles.SelectedRows.Count <= 0)
                {
                    MessageBox.Show("Please select a file!");
                    return;
                }

                timerPlay.Enabled = false;
                btnFilePlay.Text = "Play";
                trackPlay.Value = 0;

                string strFileName = gridFiles.SelectedRows[0].Cells["FileName"].Value.ToString();
                string strRet = ocxPlayBack.Commander(Obs_StartPlayBack_Cmd,
                    m_iObsID, LogonID, 1, strFileName, gridFiles.SelectedRows[0].Index, 0,
                    0, 0, 0);
                int iRet = StrToInt(strRet);
                if (iRet == 0)
                {
                    timerPlay.Enabled = true;
                    btnPlay.Text = "Stop";
                }
                else
                {
                    MessageBox.Show("Play Failed!");
                }
            }
            else
            {
                ocxPlayBack.Commander(Obs_Stop_Cmd,
                m_iObsID, 0, 0, 0, 0, 0, 0, 0, 0);
                btnPlay.Text = "Play";
                timerPlay.Enabled = false;
            }
        }

        private void timerPlay_Tick(object sender, EventArgs e)
        {
            string[] strRet = ocxPlayBack.Commander(Obs_Progress_Get, m_iObsID, 0, 0, 0, 0, 0, 0, 0, 0).Split('\n');
            int iRet = StrToInt(strRet[0]);
            if (iRet == 0)
            {
                string[] strProgress = strRet[1].Split('/');
                int iCurFrameNO = StrToInt(strProgress[0]);
                int iTotalFrame = StrToInt(strProgress[1]);
                int iPos = 0;
                try
                {
                    iPos = iCurFrameNO * 100 / iTotalFrame;
                }
                catch (System.Exception /*ex*/)
                {
                    iPos = 0;
                }
                if (iPos < 0)
                {
                    iPos = 0;
                }
                if (iPos > 100)
                {
                    iPos = 100;
                }

                trackPlay.Value = iPos;
            }
            else
            {
                //timerPlay.Enabled = false;
                AppendMsg("Obs(" + m_iObsID + ") get playing progress failed!\r\n\r\n");
            }
        }

        private void timerDownload_Tick(object sender, EventArgs e)
        {
            foreach (UInt32 uiID in m_mapDownloadID.Keys)
            {
                int iPos = GetDownloadPos(uiID);
                if (iPos >= 0)
                {
                    gridFiles.Rows[m_mapDownloadID[uiID]].Cells["Download"].Value = iPos.ToString() + "%";
                }
                else
                {
                    gridFiles.Rows[m_mapDownloadID[uiID]].Cells["Download"].Value = "Failed";
                    ocxPlayBack.Commander(Store_DLStop_Cmd, uiID, 0, 0, 0, 0, 0, 0, 0, 0);
                    m_mapDownloadID.Remove(uiID);
                    AppendMsg("Get download progress failed,stop download! DownloadID(" +
                        uiID + ")\r\n\r\n");
                }
            }

            if (m_mapDownloadID.Count <= 0)
            {
                timerDownload.Enabled = false;
                btnDownload.Text = "Download";
                AppendMsg("No download,stop download timer!\r\n\r\n");
            }
        }

        private int GetDownloadPos(UInt32 uiObsID)
        {
            int iPos = -1;
            string[] strRet = ocxPlayBack.Commander(Store_DLProgress_Get,
                uiObsID, 0, 0, 0, 0, 0, 0, 0, 0).Split('\n');
            int iRet = StrToInt(strRet[0]);
            if (iRet == 0)
            {
                iPos = StrToInt(strRet[1].Split('\b')[0]);
            }
            return iPos;
        }

        private void btnFileOpen_Click(object sender, EventArgs e)
        {
            dlgFileOpen.Filter = "(*.sdv;*.tdv;*.pdv;*.h264)|*.sdv;*.tdv;*.pdv;*.h264|All Files|*.*";
            if (dlgFileOpen.ShowDialog() == DialogResult.OK)
            {
                edtLocalFile.Text = dlgFileOpen.FileName;
            }
        }

        private void btnFilePlay_Click(object sender, EventArgs e)
        {
            if (btnFilePlay.Text == "Play")
            {
                timerPlay.Enabled = false;
                btnPlay.Text = "Play";
                trackPlay.Value = 0;
                string strRet = ocxPlayBack.Commander(Obs_StartPlayBackOffLine_Cmd,
                                m_iObsID, edtLocalFile.Text, 0, 0, 0, 0, 0, 0, 0);
                int iRet = StrToInt(strRet);
                if (iRet == 0)
                {
                    btnFilePlay.Text = "Stop";
                    timerPlay.Enabled = true;
                }
            }
            else
            {
                ocxPlayBack.Commander(Obs_Stop_Cmd,
                m_iObsID, 0, 0, 0, 0, 0, 0, 0, 0);
                btnFilePlay.Text = "Play";
                timerPlay.Enabled = false;
            }
        }

        private void AppendMsg(string strMsg)
        {
            edtMsg.Text += strMsg;
        }

        private void edtMsg_DoubleClick(object sender, EventArgs e)
        {
            edtMsg.Clear();
        }

        private void ocxPlayBack_OnPlayBack(object sender, AxSwallowLib._DSwallowEvents_OnPlayBackEvent e)
        {
            if (e._ObsID == m_iObsID && e._Event == 0)
            {
                ocxPlayBack.Commander(Obs_Stop_Cmd,
                               m_iObsID, 0, 0, 0, 0, 0, 0, 0, 0);
                btnFilePlay.Text = "Play";
                btnPlay.Text = "Play";
                timerPlay.Enabled = false;
                trackPlay.Value = 100;
                AppendMsg("Play to end!\r\n\r\n");
            }
        }

        private void ocxPlayBack_OnPlayBackDecrypt(object sender, AxSwallowLib._DSwallowEvents_OnPlayBackDecryptEvent e)
        {
            switch (e._lNotifyType)
            {
                case LMSG_PLAYBACK_NEED_DECRYPT_KEY:
                    AppendMsg("Obs(" + e._lobsId + ") Need decrypt key!\r\n\r\n");
                    break;
                case LMSG_PLAYBACK_DECRYPT_KEY_FAILED:
                    AppendMsg("Obs(" + e._lobsId + ") Decrypt failed!\r\n\r\n");
                    break;
                case LMSG_PLAYBACK_DECRYPT_SUCCESS:
                    AppendMsg("Obs(" + e._lobsId + ") Decrypt success!\r\n\r\n");
                    break;
                default:
                    break;
            }
        }

        private void btnDecrypt_Click(object sender, EventArgs e)
        {
            string strKey = edtDecrypt.Text;
            string strRet = ocxPlayBack.Commander(DEVICE_DECRYPTREC_SET, 
                m_iObsID, strKey, strKey.Length, 0, 0, 0, 0, 0, 0);
            int iRet = StrToInt(strRet);
            if (iRet != 0)
            {
                AppendMsg("Decrypt failed! Obs(" + m_iObsID + 
                    ") DecryptKey(" + strKey + ") Ret(" + 
                    iRet + ")\r\n\r\n");
            }
        }
    }
}
